from flask import request, Response
from db.repository import Repository
from db.entities import Layer

repo = Repository()

#region layers
def post():
    '''Insert a new layer or overwrite an existing one.'''
    # TODO overwrite
    body = request.json
    _insert_layer(body)
    return Response(status=201)

def _insert_layer(layer_data: dict):
    '''Converts object keys from external source and inserts into database.'''
    # layer_data['layer_name'] = layer_data.pop('LayerName')
    # layer_data['properties'] = layer_data.pop('Properties')

    repo.add_layer(Layer(layer_data))

def get_by_use_case(use_case):
    res = repo.get_layers_for_use_case(use_case)
    if len(res) > 0:
        return [l.to_serializable_dict() for l in res]
    else:
        return Response(status=404)

def get_by_table(use_case, use_case_table):
    res = repo.get_layers_for_table(use_case, use_case_table)
    if len(res) > 0:
        return [l.to_serializable_dict() for l in res]
    else:
        return Response(status=404)

def get_by_name(use_case, use_case_table, name):
    res = repo.get_layer_by_name(use_case, use_case_table, name)
    if res is not None:
        return res.to_serializable_dict() 
    else:
        return Response(status=404)

#endregion

#region nodes
def get_nodes(use_case, use_case_table, name):
    res = repo.get_layer_nodes(use_case, use_case_table, name)
    # print(res)
    return res

def post_nodes(name):
    body = request.json
    for node in body:
        node['layer_name'] = name

    repo.add_layer_nodes(body)
    return Response(status=201)

#endregion nodes