###add modules folder to interpreter path
import sys
import os
import requests
import numpy as np
import matplotlib.pyplot as plt
modules_path = '../../../modules/'
if os.path.exists(modules_path):
    sys.path.insert(1, modules_path)




######SECURITY#############
# import connecion
# from security import swagger_util
# from pathlib import Path
# from env_info import is_running_locally, get_resources_path

######PROCESSING##########

import run_clustering as clustering
import run_similarity_calc as similCalc
import processing.fetching.fetching as fetchy

import processing.similarityFiles.dataInput as inputData


from db.repository import *
repo = Repository()


def deleteSimilarityData():
    repo.delete_all_similarity_data()

def processData():
    fetchy.fetch_nodes_from_semantic_linking()
    clustering.run_clustering_for_Paper_case()
    similCalc.run_similarity_calc_for_Paper_case()

def mainViz():
    # small set
    # r = requests.get('https://drive.google.com/uc?export=download&id=1iaiFhwiadViXojYIvK1qkV2Mrf26IXme', timeout=15)
    # print("Downloaded JSON")
    # inputSimListOfDict = json.loads(r.content)
    # big set   
    print("Opening JSON")
    with open('resultSimilarityDictN100800C4206.json') as json_file:
        inputSimListOfDict = json.load(json_file)
        
    print("Opened JSON")
    
    demandLayerListOfDict = []
    for simDict in inputSimListOfDict:
        if simDict['cluster_layer']=='User_Demand_Layer':
            demandLayerListOfDict.append(simDict)

    # {
    #     "cluster1_label": 3,
    #     "cluster2_label": 5,
    #     "cluster_layer": "Demand_Layer",
    #     "similarityValues": {
    #         "Solar_Production_Layer": 0.0,
    #         "Energy_Consumption_Layer": 0.0,
    #         "Heating_Consumption_Layer": 0.0,
    #         "Price_Layer": 46340.950540531645,
    #         "Position_Layer": 0.0
    #     },
    #     "runId": "5f886e7e35b70a1704c728e6",
    #     "use_case": "paper"
    # },
    print("Starting DistribDicts")
    distributionSolar= dict()
    distributionEnergy = dict()
    distributionHeating = dict()
    distributionPrice = dict()    
    distributionPosition = dict()
    distributionTotal_Demand = dict()
    
    for entry in demandLayerListOfDict:
        similVal = entry['similarityValues']
        try:
            if checkKey(distributionSolar,similVal['Solar_Production_Layer']):
                distributionSolar[similVal['Solar_Production_Layer']] +=1
            else:
                if(similVal['Solar_Production_Layer']< 45000):
                    distributionSolar[similVal['Solar_Production_Layer']] = 1
        except:
            pass
        try:
            if checkKey(distributionEnergy,similVal['Energy_Consumption_Layer']):
                distributionEnergy[similVal['Energy_Consumption_Layer']] +=1
            else:
                if(similVal['Energy_Consumption_Layer']< 45000):
                    distributionEnergy[similVal['Energy_Consumption_Layer']] = 1
        except:
            pass
        try:
            if checkKey(distributionHeating,similVal['Heating_Consumption_Layer']):
                distributionHeating[similVal['Heating_Consumption_Layer']] +=1
            else:
                if(similVal['Heating_Consumption_Layer']< 45000):
                    distributionHeating[similVal['Heating_Consumption_Layer']] = 1
        except:
            pass
            
        try:
            if checkKey(distributionPrice,similVal['Price_Layer']):
                distributionPrice[similVal['Price_Layer']] +=1
            else:
                if(similVal['Price_Layer']< 45000):
                    distributionPrice[similVal['Price_Layer']] = 1
        except:
            pass

        try:
            if checkKey(distributionPosition,similVal['Location_Layer']):
                distributionPosition[similVal['Location_Layer']] +=1
            else:
                if(similVal['Location_Layer']< 45000):
                    distributionPosition[similVal['Location_Layer']] = 1
        except:
            pass
        
        try:
            if checkKey(distributionTotal_Demand,similVal['Demand_Layer']):
                distributionTotal_Demand[similVal['Demand_Layer']] +=1
            else:
                if(similVal['Demand_Layer']< 45000):
                    distributionTotal_Demand[similVal['Demand_Layer']] = 1
        except:
            pass


    print("\nFinishedListDistrib\n")



    #TRY TO PLOT
    #fig, axs = plt.subplots(, sharex = True)
    plt.xlabel('Eucledian Distance')
    plt.ylabel('Nr. of Cluster combinations')
    #fig.suptitle('')
    #fig.text(0.5, 0.04, 'Euclidean Distance', ha='center', va='center')

    # list1 = sorted(distributionSolar.items())
    # x2,y2 = zip(*list1)
    # plt.bar(x2,y2,color='purple',label="Solar Production", width=0.2)
    # plt.legend()
    # plt.title('Solar Production')
    #plt.yscale('log')
    

    # list1 = sorted(distributionEnergy.items())
    # x,y = zip(*list1)
    # plt.bar(x, y, color='blue',label="Energy Consumption", width=0.2)
    # plt.legend()
    # plt.title('Energy Consumption')
    # plt.yscale('log')

    # list1 = sorted(distributionHeating.items())
    # x3,y3 = zip(*list1)
    # plt.bar(x3,y3,color='red',label="Heating Consumption", width=0.3)
    # plt.legend()
    # plt.title('Heating Consumption')
    # plt.yscale('log')
    

    # list1 = sorted(distributionPrice.items())
    # x4,y4 = zip(*list1)
    # plt.bar(x4,y4,color='green',label="Price", width=0.2)
    # plt.legend()
    # plt.title('Price')
    # plt.yscale('log')

    # list1 = sorted(distributionPosition.items())
    # x5,y5 = zip(*list1)
    # plt.bar(x5,y5,color='grey',label="Location", width=0.2)
    # plt.legend()
    # plt.title('Location')
    # plt.yscale('log')

    list1 = sorted(distributionTotal_Demand.items())
    x6,y6 = zip(*list1)
    plt.bar(x6,y6,color='black',label="Total Demand", width=0.2)
    plt.legend()
    plt.title('Total Demand')
    plt.yscale('log')


    
    

    
    
    

    plt.show()
    print("FIN")
    print("\n")


    #inputData.getClusterDataFromMongo("Paper",None,None)
    #inputData.getSimilarityDataFromMongo(cluster_layer: str= None, batchSize: int=1000, run_id: str=None)
    #similarityArrFromMongo = getSimilarityDataFromMongo("Paper")

def checkKey(dict, key): 
      
    if key in dict.keys(): 
        #print("Present, ", end =" ") 
        #print(str(key)+ " : " + str(dict[key] ))
        return True
    else: 
        #print("Not present") 
        return False




#deleteSimilarityData()
#processData()
mainViz()

