
import json
import numpy as np
import matplotlib.pyplot as plt

def mainViz():
    print("Opening JSON")
    with open('EnergyDataSubset.json') as json_file:
        inputDict = json.load(json_file)

    


    distributionSolar= dict()
    distributionEnergy = dict()
    distributionHeating = dict()
    distributionPrice = dict()    
    distributionTotalDemand = dict()
    distributionUserDemand = dict()

    for entry in inputDict:
        try:
            sVal=round(float(entry['Solar_Production_kWh']),2)
            if(checkKey(distributionSolar,sVal)):
                distributionSolar[sVal] += 1
            else:
                distributionSolar[sVal] = 1
        except Exception as E:
            print(E)

        try:
            eVal=round(float(entry['Energy_Consumption_kWh']),2)
            if(checkKey(distributionEnergy,eVal)):
                distributionEnergy[eVal] += 1
            else:
                distributionEnergy[eVal] = 1
        except:
            pass
        
        try:
            hVal=round(float(entry['Heating_Consumption_kWh']),2)
            if(hVal > 0):
                if(checkKey(distributionHeating,hVal)):
                    distributionHeating[hVal] += 1
                else:
                    distributionHeating[hVal] = 1
        except:
            pass
        
        try:
            pVal=round(float(entry['Price_AUD_MWh']),2)
            if(checkKey(distributionPrice,pVal)):
                distributionPrice[pVal] += 1
            else:
                distributionPrice[pVal] = 1
        except:
            pass
        
        try:
            tdVal=round(float(entry['Total_Demand_MWh']),2)
            if(checkKey(distributionTotalDemand,tdVal)):
                distributionTotalDemand[tdVal] += 1
            else:
                distributionTotalDemand[tdVal] = 1
        except:
            pass

        try:
            eVal=round(float(entry['Energy_Consumption_kWh']),2)
            hVal=round(float(entry['Heating_Consumption_kWh']),2)
            udVal = round((eVal+hVal),2)
            if(checkKey(distributionUserDemand,udVal)):
                distributionUserDemand[udVal] += 1
            else:
                distributionUserDemand[udVal] = 1
        except:
            pass


    
    plt.ylabel('Nr. of Entries')
    

    # ### SOLAR 
    # list1 = sorted(distributionSolar.items())
    # x2,y2 = zip(*list1)
    # plt.bar(x2,y2,color='purple',label="Solar", width=0.005)
    # plt.legend()
    # plt.title('Solar Production')
    # plt.xlabel('kWh')
    # plt.show()

    # plt.xlabel('Unit of measurement')
    # plt.ylabel('Nr. of Entries')
    # plt.xticks(np.linspace(0,4.5,num=20))

    # ### ENERGY
    # list1 = sorted(distributionEnergy.items())
    # x2,y2 = zip(*list1)
    # plt.bar(x2,y2,color='blue',label="Energy", width=0.005)
    # plt.legend()
    # plt.title('Energy Consumption')
    # plt.xlabel('kWh')
    # plt.show()


    #plt.xticks(np.linspace(0,4.5,num=20))

    ## Heating
    # list1 = sorted(distributionHeating.items())
    # x2,y2 = zip(*list1)
    # plt.bar(x2,y2,color='red',label="Heating", width=0.01)
    # plt.legend()
    # plt.title('Heating Consumption')
    # plt.xlabel('kWh')
    # plt.show()

    ## Price
    # #plt.xticks(np.linspace(0,100,num=10))
    # list1 = sorted(distributionPrice.items())
    # x2,y2 = zip(*list1)
    # plt.bar(x2,y2,color='green',label="Price", width=0.5)
    # plt.legend()
    # plt.title('Price')
    # plt.xlabel('MWh')
    # plt.show()

    ### Demand
    plt.xticks(np.linspace(0,100,num=10))
    list1 = sorted(distributionTotalDemand.items())
    x2,y2 = zip(*list1)
    plt.bar(x2,y2,color='black',label="Total Demand", width=5)
    plt.legend()
    plt.title('Total Demand')
    plt.xlabel('MWh')
    plt.show()

    ## User Demand

    #plt.xticks(np.linspace(0,100,num=10))
    # list1 = sorted(distributionUserDemand.items())
    # x2,y2 = zip(*list1)
    # plt.bar(x2,y2,color='orange',label="User Demand", width=0.01)
    # plt.legend()
    # plt.title('User Demand')
    # plt.xlabel('kWh')
    # plt.show()



    print("FIN")
        
        


def checkKey(dict, key): 
      
    if key in dict.keys(): 
        #print("Present, ", end =" ") 
        #print(str(key)+ " : " + str(dict[key] ))
        return True
    else: 
        #print("Not present") 
        return False


mainViz()