import unittest
import manage_sys_paths
import json

from messaging.MessageHandler import MessageHandler
from messaging.DummyMessageManager import DummyMessageManager as DummyMessageSender
    
class DummyMongoRepo:
    '''Dummy class to be used for testing the MessageHandler'''
    last_trace = None
    def insert_trace(self, trace):
        self.last_trace = trace

class Test_Pipeline(unittest.TestCase):
    handler = None
    repo = None
    msg_sender = None

    def setUp(self):
        self.repo = DummyMongoRepo()
        self.msg_sender = DummyMessageSender.get_instance()
        self.handler = MessageHandler()
    
    def _buildTraceMessage(self):
        return {
            "type": "new-trace", 
            "content": {
                'use_case': 'debug', 
                'table': 'pizza', 
                'id': '9e1e0983ada4e79de324a80b5f35f681c3e5016b08e1d6612c17892ade17e2c0', 
                'properties': {
                    'UniqueID': '9e1e0983ada4e79de324a80b5f35f681c3e5016b08e1d6612c17892ade17e2c0', 
                    'cheese': False, 
                    'dough': 'wheat', 
                    'name': 'Margherita', 
                    'sauce': 'tomato', 
                    'sugar': 0.0
                }
            }
        }

    def testTraceProcessing(self):
        msg = self._buildTraceMessage()
        self.handler.handle_new_trace(msg["content"])
    

if __name__ == '__main__':
    unittest.main()