import sys
import os
from pathlib import Path
from typing import Dict, Any
import requests

modules_path = '../../../modules/'
if os.path.exists(modules_path):
    sys.path.insert(1, modules_path)

import network_constants as nc
from security.token_manager import TokenManager


import tables.add_user as user
import tables.add_car as car
import tables.add_offer as offer
import tables.add_travel as travel
import tables.add_hash as add_hash


def add_use_case(use_case: str):
    use_case = "car-sharing"

    jwt = TokenManager.getInstance().getToken()
    url = f"https://articonf1.itec.aau.at:30420/api/use-cases"
    response = requests.post(
            url,
            verify=False, 
            proxies = { "http":None, "https":None },
            headers = { "Authorization": f"Bearer {jwt}"},
            json = {"name": use_case}
        )
    
    print(url+": "+str(response.status_code))
        

if __name__ == "__main__":
    use_case = "car-sharing"
    
    # disable ssl warnings :) 
    requests.packages.urllib3.disable_warnings() 

    add_use_case(use_case)
    user.main(use_case)
    car.main(use_case)
    offer.main(use_case)
    travel.main(use_case)
    add_hash.main(use_case)