import network_constants as nc
from security.token_manager import TokenManager

import requests

def add_table(use_case: str):
    '''
    take the columns and add the mappings at the server
    replace all "/"'s in the internal representation with a "_"
    '''
    jwt = TokenManager.getInstance().getToken()

    # TODO check back with alex

    use_case = "car-sharing"
    columns = [
        # "docType",
        "id",
        # "car",
        "priceForKm",
        "priceForTime",
        "startDate",
        "endDate",
        "deposit",
        # "startPlace",
        # "endPlaces",
        "available",
        "deleted",
        # "cancelledBy",
        "carOwner",
        # "checkedBy",
        # "finishedBy",
        "offererId"
    ]
    
    columns = { c : c for c in columns }
    columns["UniqueID"] = "id"
    
    url = f"https://articonf1.itec.aau.at:30420/api/use-cases/{use_case}/tables"

    table = {
        "name": "offer",
        "mappings": columns
    }

    response = requests.post(
            url,
            verify=False, 
            proxies = { "http":None, "https":None },
            headers = { "Authorization": f"Bearer {jwt}"},
            json = table
        )

    print(url+": "+str(response.status_code))

def main(use_case: str):
    print("OFFER")
    add_table(use_case)