import network_constants as nc
from security.token_manager import TokenManager

import requests

def add_table(use_case: str):
    '''
    take the columns and add the mappings at the server
    replace all "/"'s in the internal representation with a "_"
    '''
    jwt = TokenManager.getInstance().getToken()

    use_case = "car-sharing"
    columns = [
        # "doctype",
        "id", # pk
        "balance",
        "payerId",
        "numberOfTrips",
        "sumOfTripsScores"
    ]
    
    columns = { c : c for c in columns }
    columns["UniqueID"] = "id"
    
    url = f"https://articonf1.itec.aau.at:30420/api/use-cases/{use_case}/tables"

    table = {
        "name": "user",
        "mappings": columns
    }

    response = requests.post(
            url,
            verify=False, 
            proxies = { "http":None, "https":None },
            headers = { "Authorization": f"Bearer {jwt}"},
            json = table
        )

    print(url+": "+str(response.status_code))

def main(use_case: str):
    print("USER")
    add_table(use_case)